
tree nl_eval_program PARAMS((tree expr));
tree nl_eval PARAMS((tree expr));

unsigned int nl_hash(tree key);
int nl_eql(tree t1, tree t2);
tree nl_to_string( tree t );

extern GTY(()) tree global_namespace;
extern GTY(()) tree current_namespace;
extern GTY(()) struct nl_environment *current_env;

struct nl_environment GTY(())
{
  tree namespace_list;
  struct nl_environment *chain; /* for environment stack */
};

void push_environment( tree base_namespace );
void set_environment( tree namespace_list );
void pop_environment( void );

void push_namespace( tree ns );
tree pop_namespace( void );

/* for native function */
tree nl_define_namespace( tree ns, const char *id );
void nl_define_native( tree ns, tree(*func)(tree), const char *id, int );

tree nl_lookup_entry( tree id );
tree nl_lookup( tree id );

extern GTY(()) tree nl_true;
extern GTY(()) tree nl_false;
extern GTY(()) tree nl_nil;

extern GTY(()) tree nl_retval;

void nl_init(void);

struct nl_ggc_prot GTY(())
{
  struct nl_ggc_prot *chain;
  tree value;
};

extern GTY(()) struct nl_ggc_prot *nl_prot_root;

#define NL_BEGIN_PROTECT struct nl_ggc_prot *pprroott__ = nl_prot_root

#define NL_PROTECT(NODE) do { struct nl_ggc_prot *prot = ggc_alloc( sizeof(struct nl_ggc_prot) );\
	prot->value = NODE;\
	prot->chain = nl_prot_root;\
	 nl_prot_root = prot;\
}while (0)

#define NL_END_PROTECT nl_prot_root = pprroott__

void nl_init_std(void);

#define NL_IS_FALSE(NODE) ( ((NODE)==nl_false) || ((NODE)==nl_nil) ||\
				((NODE)==NULL) || \
				((TREE_CODE(NODE)==INTEGER_CST) && (TREE_INT_CST_LOW(NODE)==0)) )


tree build_function( tree args, tree body );

