#include "config.h"
#include "system.h"
#include "coretypes-wrapper.h"
#include "tree.h"
#include "ggc.h"
#include "c-common.h"
#include "langhooks.h"
#include "langhooks-def.h"
#include "flags.h"

#include "tokens.h"
#include "lex.h"
#include "asdf-tree.h"
#include "decl.h"
#include "error.h"
#include "nl-eval.h"

void asdf_parse_file PARAMS((int));
tree asdf_truthvalue_conversion PARAMS((tree));

void c_insert_default_attributes PARAMS((tree decl));

#undef LANG_HOOKS_PARSE_FILE
#define LANG_HOOKS_PARSE_FILE asdf_parse_file

#undef LANG_HOOKS_NAME
#define LANG_HOOKS_NAME	"asdf compiler (zxc)"

#undef LANG_HOOKS_TREE_SIZE
#define LANG_HOOKS_TREE_SIZE asdf_tree_size

#define LANG_HOOKS_TRUTHVALUE_CONVERSION asdf_truthvalue_conversion
#define LANG_HOOKS_SIGNED_TYPE c_common_signed_type
#define LANG_HOOKS_UNSIGNED_TYPE c_common_unsigned_type
#define LANG_HOOKS_SIGNED_OR_UNSIGNED_TYPE c_common_signed_or_unsigned_type
#define LANG_HOOKS_TYPE_FOR_MODE c_common_type_for_mode
#define LANG_HOOKS_TYPE_FOR_SIZE c_common_type_for_size

#define LANG_HOOKS_MARK_ADDRESSABLE asdf_mark_addressable

static bool asdf_init PARAMS ((void));
static void asdf_finish PARAMS((void));
static void write_global_declarations PARAMS((void));

#undef LANG_HOOKS_INIT
#define LANG_HOOKS_INIT asdf_init
#undef LANG_HOOKS_FINISH 
#define LANG_HOOKS_FINISH asdf_finish


bool asdf_mark_addressable(tree);

bool 
asdf_mark_addressable(tree e) 
{ 
  return false;
}

static void write_global_declarations(void)
{}

const struct lang_hooks lang_hooks = LANG_HOOKS_INITIALIZER;

#define DEFTREECODE(SYM,NAME,TYPE,LENGTH) TYPE,
const char tree_code_type[] = {
#include "tree.def"
  'x',
#include "c-common.def"
  'x',
#include "asdf-tree.def"
};
#undef DEFTREECODE

#define DEFTREECODE(SYM, NAME, TYPE, LENGTH) LENGTH,
const unsigned char tree_code_length[] = {
#include "tree.def"
  0,
#include "c-common.def"
  0,
#include "asdf-tree.def"
};
#undef DEFTREECODE

#define DEFTREECODE(SYM, NAME, TYPE, LEN) NAME,
const char *const tree_code_name[] = {
#include "tree.def"
  "@@dummy",
#include "c-common.def"
  "@@dummy",
#include "asdf-tree.def"
};
#undef DEFTREECODE

static void
asdf_finish(void)
{

}

static bool
asdf_init( )
{
  input_line = 1;

  if ( input_filename == NULL ) {
    printf ("usage: zxc file_name\n");
    return false;
  }

  init_lex_buffer( input_filename );

  build_common_tree_nodes (flag_signed_char);
  init_reswords();

  return true;
}

#include "debug.h"
#include "gtype-asdf.h"
